<template>
  <div class="m-card-form">
    <div class="m-card-form__title">
      <resizable-textarea>
        <textarea
          class="m-card-form__input m-card-form__title-input"
          :class="{ 'is-invalid': isTitleEmpty }"
          placeholder="Заголовок"
          maxlength="224"
          v-model.trim="murrCardTitle"
        />
      </resizable-textarea>

      <div v-if="isTitleEmpty" class="m-card-form__title-invalid">
        У каждого мурра есть несколько слов
      </div>
    </div>

    <div class="m-card-form__textarea" id="editorjs"></div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import EditorJS from "@editorjs/editorjs";
import Header from "@editorjs/header";
import ImageTool from "@editorjs/image";
import CodeTool from "@editorjs/code";

import { axios_defaults_baseURL as AXIOS_DEFAULT_BASE_URL } from "../../../devAndProdVariables.js";

import ResizableTextarea from "../../common/ResizableTextarea.js";

import "cropperjs/dist/cropper.css";

export default {
  name: "MurrCardTextarea",

  components: {
    ResizableTextarea,
  },

  props: {
    murrDataLocalStorage: Object,
    isTitleEmpty: Boolean,
  },

  data: () => ({
    murrCardTitle: "",
    murrCardContent: "",
  }),

  computed: {
    ...mapGetters({
      currentMurren: "currentMurren",
    }),
  },

  methods: {
    initEditorJS(murrCardContent) {
      if (murrCardContent?.blocks) {
        this.murrCardContent = this.factoryContent(murrCardContent.blocks);
      }

      window.editor = new EditorJS({
        logLevel: "ERROR",
        onChange: (api) => {
          api.saver.save().then(({ blocks }) => {
            this.murrCardContent = this.factoryContent(blocks);
          });

          document
            .getElementById("modalWindow")
            .scrollBy(0, document.body.scrollHeight);
        },
        tools: {
          header: Header,
          code: {
            class: CodeTool,
            config: {
              placeholder: "Введи код",
            },
          },
          image: {
            class: ImageTool,
            config: {
              additionalRequestHeaders: {
                Authorization: `Bearer ${this.currentMurren.token}`,
              },
              captionPlaceholder: "Коммент к фото (не обязательно)",
              field: "murr_editor_image",
              endpoints: {
                byFile: `${AXIOS_DEFAULT_BASE_URL}/api/murr_card/save_editor_image/`,
              },
            },
          },
          paragraph: {
            config: {
              preserveBlank: true,
              placeholder: "Расскажи свою историю...",
            },
          },
        },
        data: this.murrCardContent,
      });
    },

    handlerBroadcastEvent() {
      this.$emit("change", {
        title: this.murrCardTitle,
        content: this.murrCardContent,
      });
    },

    factoryContent(blocks) {
      for (let node of blocks) {
        if (node.type === "image" || node.type === "code") {
          return { blocks };
        } else if (node.data.text.length > 0) {
          return { blocks };
        }
      }

      return "";
    },
  },

  watch: {
    murrCardTitle() {
      this.handlerBroadcastEvent();
    },

    murrCardContent() {
      this.handlerBroadcastEvent();
    },
  },

  mounted() {
    this.murrCardTitle = this.murrDataLocalStorage.title;
    this.murrCardContent = this.murrDataLocalStorage.content;

    this.initEditorJS(this.murrCardContent);
  },

  beforeDestroy() {
    window.editor = null;
    delete window.editor;
  },
};
</script>
